package main

/** COS 418 Fall 2022
Professor Wyatt Lloyd

Author: Jennifer Lam
**/

import (
	"flag"
	"fmt"
	"sync"
)

func main() {

	n := flag.Int("n", 3, "number of goroutines, default 3")
	flag.Parse()

	// the input slice, assume numbers 1-7 and 100
	slice2Bsquared := []int{1, 2, 3, 4, 5, 6, 7, 100}
	fmt.Printf("original: %+v\n", slice2Bsquared)

	// resulting slice of squared numbers
	result := make([]int, len(slice2Bsquared))

	type Pair struct {
		Idx int
		Val int
	}
	ch := make(chan Pair, len(slice2Bsquared))
	var wg sync.WaitGroup
	for idx, val := range slice2Bsquared {
		ch <- Pair{idx, val}
		wg.Add(1)
	}

	// spin off goroutines
	for i := 0; i < *n; i++ {
		go func() {
			for {
				pair := <-ch
				result[pair.Idx] = pair.Val * pair.Val
				wg.Done()
			}
		}()
	}
	wg.Wait()

	fmt.Printf("result: %+v\n", result)
}
